
package magercises.cats.solution;


/* 
	Use the WaitStack (a blocking stack) to act as an argument stack
	for a simple consumer.  Here the consumer, CatMachine, waits until
	it can pull out some number of objects from its input stack, cats
	them together as strings, then sends it to it's output, which is
	another consumer.  A new subclass of TextArea is introduced to 
	act as a final consumer and show the output.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

public class CatTest extends Applet {
  ConsumerTextArea output;


  public void init() {
	setLayout(new FlowLayout());
	add(output = new ConsumerTextArea(5,50));

	CatMachine cat1 = new CatMachine(2,output);
	CatMachine cat2 = new CatMachine(1,cat1);
	CatMachine cat3 = new CatMachine(2,cat1);
	cat1.start();
	cat2.start();
	cat3.start();
	cat2.inputItem("foo ");
	cat3.inputItem("bar ");
	cat3.inputItem("baz ");
  }    
}