
package magercises.facade.solution;


/* Using a facade w/ sync methods
   There are two entities with a 1 - 1 relationship, a person
   to a locker,  the registrar object handles reassignment of 
   persons to locker, this avoids potential deadlock.
   (ref. integrity requires that old owner of locker must
   be updated to null)
   (make registration a static method ?)
   how to make live?

*/

import java.awt.*;
import java.applet.Applet;


public class FacadeTest extends Applet {
  Person bob;
  Person fred;
  Locker aLocker;
  Registrar registrar;
  LockerSwitcher ls1;
  LockerSwitcher ls2;
  TextArea output;
  int threadCount = 0;


  public void init() {
	setLayout(new FlowLayout());
	add(output = new TextArea(5,40));
  }    
  public void start() {
	bob = new Person("bob");
	fred = new Person("fred");
	aLocker = new Locker("101");
	registrar = new Registrar();
	ls1 = new LockerSwitcher(bob,aLocker,registrar,this);
	ls2 = new LockerSwitcher(fred,aLocker,registrar,this);
	ls1.start();
	ls2.start();
  }    
  /** print the string to the output window */
  public synchronized void threadDone() {
	if(threadCount < 1)  {
	threadCount++;
	return;
	  }
	else {
	  output.setText(bob.toString() + fred.toString() 
		     + aLocker.toString());
	}
  }    
}