
package magercises.facade.solution;


/* Using a facade w/ sync methods
   There are two entities with a 1 - 1 relationship, a person
   to a locker,  the registrar object handles reassignment of 
   persons to locker, this avoids potential deadlock.
   (ref. integrity requires that old owner of locker must
   be updated to null)
   (make registration a static method ?)
   how to make live?

*/

import java.awt.*;
import java.applet.Applet;


class LockerSwitcher extends Thread {
  Person person;
  Locker locker;
  Registrar registrar;
  FacadeTest facadeTestApplet;


  public LockerSwitcher(Person p, Locker l, 
			Registrar r, FacadeTest a) {
	person = p;
	locker = l;
	registrar = r;
	facadeTestApplet = a;
  }    
  public void run() {
	for(int i = 0; i < 20; i++) {
	  registrar.registerLockerToPerson(locker,person);
	}
	facadeTestApplet.threadDone();
  }    
}