
package magercises.facade.solution;


/* Using a facade w/ sync methods
   There are two entities with a 1 - 1 relationship, a person
   to a locker,  the registrar object handles reassignment of 
   persons to locker, this avoids potential deadlock.
   (ref. integrity requires that old owner of locker must
   be updated to null)
   (make registration a static method ?)
   how to make live?

*/

import java.awt.*;
import java.applet.Applet;


class Registrar {


  public synchronized void registerLockerToPerson(Locker l, Person p) {
	 if(l.owner != null) l.owner.locker = null;
	 l.owner = p;
	 if(p.locker != null) p.locker.owner = null;
	 p.locker = l;
  }    
}