
package magercises.priority.solution;

/*  demonstrate nature of thread sheduling, use a thread graph, a 
	bar graph that reports ping activity on the graph by different
	threads.  Show how priority, yield(), sleep(), i/o blocking,
	and thread implementation affect thread liveness. */

import java.awt.*;
import java.applet.Applet;


class ThreadGraph extends Canvas {
  protected static int MAXSIZE = 400;
  int history[] = new int[MAXSIZE];
  int count = 0;


  public ThreadGraph() {

  }    
  public Dimension minimumSize() {
	return new Dimension(MAXSIZE,150);
  }    
  public void paint(Graphics g) {
	 for(int i = 0; i < count; i++) {
	   switch(history[i])   {
	   case 1: g.setColor(Color.red); break;
	   case 2: g.setColor(Color.blue); break;
	   case 3: g.setColor(Color.green); break;
	   default: g.setColor(Color.black); break;
	   }
	   g.drawLine(i,0,i,50);       
	 }
  }    
  public synchronized boolean ping(int i) {
	if(count >= MAXSIZE) return false;
	history[count] = i; 
	count++;
	repaint();
	return true;
  }    
  public Dimension preferredSize() {
	return minimumSize();
  }    
  public void update(Graphics g) {
	 paint(g);
  }    
}