
package magercises.runnable.solution;

/* Solution to the Runnable Magercise.
   The ClockPanel class is an AWT Component that
   updates its display every second.  
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Date;

class ClockPanel extends Panel implements Runnable {
  Thread t;


  public ClockPanel() {
	t = new Thread(this);
	t.start();   
  }    
  /** implement to make sure the ClockPanel is not 
	  resized to zero */
  public Dimension minimumSize() {
	return new Dimension(150,100);
  }    
  public void paint(Graphics g) {
	 Date now = new Date();
	 g.drawString("" + now.getHours() + ":"
		  + now.getMinutes() + ":"
		  + now.getSeconds(), 30, 30);
  }    
  public Dimension preferredSize() {
	return minimumSize();
  }    
  public void run() {
	 while (true) {
	   try { t.sleep(1000);  }
	   catch (InterruptedException e) { }

	   repaint();
	 }
  }    
}