
package magercises.syncmethods.solution;


/* 
   Simple use of synch methods to avoid an invalid
   state in an object by serializing access to it,
   in this case, a simple stack.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class SimpleStack {
  protected Vector stackVector;
  

  public SimpleStack() {
	stackVector = new Vector(10);
  }    
  /** pop will return null if stack is empty */
  public synchronized Object pop() {
	int size = stackVector.size();
	Object item;
	if(size == 0) 
	  return null;
	else {
	  item = stackVector.elementAt(size-1);
	  stackVector.removeElementAt(size-1);
	  return item;
	}
  }    
  public synchronized void push(Object item) {
	stackVector.addElement(item);
  }    
  public synchronized String toString() {
	return "SimpleStack: " + stackVector;
  }    
}